# -*- coding: utf-8 -*- 

###########################################################################
## Python code generated with wxFormBuilder (version May 19 2010)
## http://www.wxformbuilder.org/
##
## PLEASE DO "NOT" EDIT THIS FILE!
###########################################################################

import wx
from wx.lib.pubsub import Publisher
from wx.lib.mixins.listctrl import CheckListCtrlMixin, ListCtrlAutoWidthMixin
import threading
from threading import Thread
import shlex, subprocess
import xmlrpclib
import paramiko
import pexpect
import signal
import os
import sys, socket
import time
from xml.etree import ElementTree as ET
from ros import rosnode
from ros import rospy
import roslib.scriptutil as scriptutil

#allow to set clipboard message. such as "export ROSMASTER=xxx:11311"
import pygtk
pygtk.require('2.0')
import gtk
clipboard = gtk.clipboard_get()

#allow remote access of environment variables
import pxssh



#from IPython.Debugger import Tracer

from shutdownbox import *

from textctrl import PythonSTC

#debug_here = Tracer()

wx.ID_WS = 1000
wx.ID_MS = 1001

launch_file = os.path.abspath(__file__)
launch_file = os.path.dirname(launch_file)

#launchfiles_on_robot = [os.path.join(launch_file, 'robot_on_robot.launch'),
#os.path.join(launch_file, 'telejoy_on_robot.launch'),
#os.path.join(launch_file, 'laser_on_robot.launch'),
#os.path.join(launch_file, 'camera_on_robot.launch')]

#setups on the remote robot
robotname = "robot"
username = "robot"
passw = "nifti"

logfile = os.path.join(launch_file,"nifti_dev_gui.xml")
launch_remote_core = False
launch_remote_core_pid = None

launchfiles_local = []
#can not work inside the class..
def start_roscore_robot(passw):
    global launch_remote_core
    global launch_remote_core_pid
    pexpfile = os.path.join(launch_file, 'pexp.py')
    cmd = ('python %s %s %s %s &'%(pexpfile, robotname, username, passw)).encode('ascii', 'ignore')
    print cmd
    args = shlex.split(cmd)
    launch_remote_core = True
    launch_remote_core_pid = subprocess.Popen(args)
        

def kill_roscore_robot(passw):
    global launch_remote_core
    launch_remote_core=False
    ps = pexpect.spawn('ssh %s@%s'%(username, robotname))
    ps.expect("%s@%s's password: "%(username, robotname))
    time.sleep(0.1)
    ps.sendline(passw)
    print "password sent"
    time.sleep(0.3)
    ps.expect("[#\$] ")
    print "shell received"
    time.sleep(0.1)
    ps.sendline("nohup kill -9 $(ps aux | grep -v grep | egrep rosmaster\|roscore\|rosout | awk '{print $2}')")
    print "message sent"
    time.sleep(2)
    ps.close(force=True)

def kill_everything_robot(passw):
    global launch_remote_core
    launch_remote_core=False
    ps = pexpect.spawn('ssh %s@%s'%(username, robotname))
    ps.expect("%s@%s's password: "%(username, robotname))
    time.sleep(0.1)
    ps.sendline(passw)
    print "password sent"
    time.sleep(0.3)
    ps.expect("[#\$] ")
    print "shell received"
    time.sleep(0.1)
    ps.sendline("nohup kill -9 $(ps aux | grep -v grep | egrep ros | awk '{print $2}')")
    print "message sent"
    time.sleep(2)
    ps.close(force=True)

def shutoff_robot():
    global launch_remote_core
    launch_remote_core=False
    ps = pexpect.spawn('ssh %s@%s'%(username,robotname))
    ps.expect("%s@%s's password: "%(username,robotname))
    time.sleep(0.1)
    ps.sendline('nifti')
    print "password sent"
    time.sleep(0.3)
    ps.expect("[#\$] ")
    print "shell received"
    time.sleep(0.1)
    ps.sendline('sudo shutdown now -P')
    time.sleep(1.0)
    ps.expect("%s: "%username)
    time.sleep(0.1)
    ps.sendline("%s"%passw)
    time.sleep(1.0)
    print "message sent"
    ps.close(force=True)

def locate_package_of_file(path):
    if path is "":
        return ""
    t = os.path.dirname(path)
    lt = os.listdir(t)
    while t is not "/":
        if "manifest.xml" in lt:
            break
        else:
            t = os.path.dirname(t)
            lt = os.listdir(t)
    if t is '/':
        print "not a valid launch file"
        return ""
    else:
        tt=t.split('/')
        print "package name is: ", tt[-1]
        return tt[-1]




class check_roscore_thread(Thread):
    def __init__(self, wxObject):
        Thread.__init__(self)
        self.wxObject = wxObject
        self.start()

    def run(self):
        #for i in range(6):
        while True:
            if self.wxObject.m_checkBox_check_roscore.GetValue():
                time.sleep(0.2)
                wx.CallAfter(self.check_roscore)
                time.sleep(0.5)
                wx.CallAfter(Publisher().sendMessage, "status", "Thread finished!")
            else:
                time.sleep(0.2)
                wx.CallAfter(Publisher().sendMessage, "status", -1)

    def check_roscore(self):
        m = xmlrpclib.ServerProxy(os.environ['ROS_MASTER_URI'])
        try:
            #print "Incoming..."
            #m.getUri()
            code, msg, val = m.getSystemState('/')
#            code, msg, val = m.getSystemState('/')
            #print "RPC OK."
        except xmlrpclib.ProtocolError, err:
            print err
            print "ROSCORE died!"
            Publisher().sendMessage("status", 1)
        except xmlrpclib.Fault, err:
            print err
            print "ROSCORE died!"
            Publisher().sendMessage("status", 1)
        except socket.error, err:
            print err
            print "ROSCORE died!"
            Publisher().sendMessage("status", 1)
        except:
            print sys.exc_info()[0]
            print "ROSCORE died!"
            Publisher().sendMessage("status", 1)
        else:
            #print "ROSCORE OK!"
            Publisher().sendMessage("status", 0)
        #print "Done."

class CheckListCtrl(wx.ListCtrl, CheckListCtrlMixin, ListCtrlAutoWidthMixin):
    def __init__(self, parent):
        wx.ListCtrl.__init__(self, parent, -1, style=wx.LC_REPORT | wx.SUNKEN_BORDER)
        CheckListCtrlMixin.__init__(self)
        ListCtrlAutoWidthMixin.__init__(self)
        

class TextFrame ( wx.Dialog):
    
    def __init__( self, parent, id ):
        wx.Dialog.__init__ ( self, parent, id = id, title = wx.EmptyString, pos = wx.DefaultPosition, size = wx.Size( 663,643 ), style = wx.DEFAULT_DIALOG_STYLE )
        
        self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
        
        bSizer1 = wx.BoxSizer( wx.VERTICAL )
# use textctrl       
#        self.m_textCtrl1 = wx.TextCtrl( self, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, wx.TE_MULTILINE )
#        bSizer1.Add( self.m_textCtrl1, 8, wx.ALL|wx.EXPAND, 5 )

#use STC
        self.m_textCtrl1 = PythonSTC( self, wx.ID_ANY, style = wx.NO_FULL_REPAINT_ON_RESIZE )
        bSizer1.Add( self.m_textCtrl1, 8, wx.ALL|wx.EXPAND, 5 )

        self.m_button_close = wx.Button(self, wx.ID_ANY, u"Close", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer1.Add( self.m_button_close, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.ALL, 5 )
        
        self.SetSizer( bSizer1 )
        self.Layout()
        
        self.Centre( wx.BOTH )

        self.m_button_close.Bind(wx.EVT_BUTTON, self.onClose)

    def onClose(self, evt):
        self.Close()
        evt.Skip()
    
    def __del__( self ):
        pass
###########################################################################
## Class nifti_dev_gui
###########################################################################

class nifti_dev_gui ( wx.Frame ):
    global robotname
    global username
    global passw
    
    def __init__( self, parent, flag_exit):
        wx.Frame.__init__ ( self, parent, id = wx.ID_ANY, title = u"ROS developer GUI", pos = wx.DefaultPosition, size = wx.Size( 1461,540 ), 
                    style = wx.DEFAULT_FRAME_STYLE|wx.TAB_TRAVERSAL)
        #wx.Panel.__init__ ( self, parent, id = wx.ID_ANY, title = u"ROS developer GUI", pos = wx.DefaultPosition, size = wx.Size( 1461,540 ), 
        #            style = wx.RAISED_BORDER|wx.TAB_TRAVERSAL)
        #wx.panel = wx.Panel(self, -1)
       
        self.flag_exit = flag_exit
        self.roscore_status = -1 #unknown, 0: running, 1: Error, -1:ignore
        self.roscore_ledstatus = -1 #unknown, 0: running, 1: Error, -1: ignore
       
        #list of components that related to launchers
        self.checkboxes_launcher=[]
        self.choices_launcher=[]
        self.valid_launcher = [] #counter, except the ""'s
        self.pid_launcher=[None, None,None, None,None, None,None ]
##############################################
        #other variables
        self.list_of_topics = []
        self.list_of_nodes = []
        self.list_nodes_contained_in_launchers = []
        #other "global states variables"
        self.LaunchedOnce = False
        self.remote_package_path = "/home/robot/bleeding-edge:/opt/ros/diamondback/stacks"
        self.remote_ros_root = "/opt/ros/diamondback/ros"
        
        self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
        self.SetExtraStyle( wx.FRAME_EX_METAL )
        
        #self.gSizer1 = wx.GridSizer( 1, 3, 0, 0 )
        self.gSizer1 = wx.BoxSizer( wx.HORIZONTAL )

########################################
        
        self.Workspace = wx.StaticBoxSizer( wx.StaticBox( self, wx.ID_WS, u"Workspace" ), wx.VERTICAL )
        self.Workspace.SetMinSize(wx.Size(400,510))
        
        bSizer1 = wx.BoxSizer( wx.VERTICAL )
        bSizer3 = wx.BoxSizer( wx.HORIZONTAL )
       
        sizer_core = wx.BoxSizer(wx.VERTICAL)
        self.m_bitmap1 = wx.StaticBitmap( self, wx.ID_ANY, wx.NullBitmap, wx.DefaultPosition, wx.DefaultSize, 0 )
        sizer_core.Add( self.m_bitmap1, 0, wx.ALL, 5 )
        self.m_checkBox_check_roscore= wx.CheckBox( self, wx.ID_ANY, u"Obs. Roscore", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_checkBox_check_roscore.SetValue(False) 
        sizer_core.Add( self.m_checkBox_check_roscore, 0, wx.ALL, 5 )
        bSizer3.Add(sizer_core, 0, wx.ALL, 1)

        bSizercore = wx.BoxSizer( wx.VERTICAL )
        self.m_button_start_roscore = wx.Button( self, wx.ID_ANY, u"Start ROSCORE at MASTER_URI", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizercore.Add( self.m_button_start_roscore, 0, wx.ALL, 1 )
        self.m_button_kill_roscore = wx.Button( self, wx.ID_ANY, u"Stop ROSCORE at MASTER_URI", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizercore.Add( self.m_button_kill_roscore, 0, wx.ALL, 1 )
        self.m_button_ping_host= wx.ToggleButton( self, wx.ID_ANY, u"Ping MASTER_URI", wx.DefaultPosition, wx.Size(210, -1), 0 )
        bSizercore.Add( self.m_button_ping_host, 0, wx.ALL, 1 )
        bSizer3.Add( bSizercore, 0, wx.ALL, 1 )

        sizer_red = wx.BoxSizer(wx.VERTICAL)
        self.m_kill_everything = wx.Button( self, wx.ID_ANY, u"Kill Everything with ROS", wx.DefaultPosition, wx.Size(200, -1), 0 )
        self.m_kill_everything.SetForegroundColour(wx.Colour(255,0,0))
        sizer_red.Add( self.m_kill_everything, 0, wx.EXPAND, 1 )
        self.m_button_shutoff_robot= wx.Button( self, wx.ID_ANY, u"SHUTOFF Robot", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_button_shutoff_robot.SetForegroundColour(wx.Colour(255,0,0))
        sizer_red.Add( self.m_button_shutoff_robot, 0, wx.EXPAND, 1 )
        self.m_button_quit = wx.Button( self, wx.ID_ANY, u"QUIT", wx.DefaultPosition, wx.DefaultSize, 0 )
        sizer_red.Add( self.m_button_quit, 0, wx.EXPAND, 1 )
        bSizer3.Add(sizer_red, 0, wx.ALL, 1)

        bSizer1.Add( bSizer3, 0, wx.EXPAND, 1 )

        #------------------------
        
        bSizer4 = wx.BoxSizer( wx.HORIZONTAL )
        self.m_staticText3 = wx.StaticText( self, wx.ID_ANY, u"MASTER_URI", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_staticText3.Wrap( -1 )
        bSizer4.Add( self.m_staticText3, 0, wx.ALL, 1 )

        mastername = os.environ["ROS_MASTER_URI"]
        mastername = mastername.split(':')[1].split('//')[1]
        #self.m_textCtrl1 = wx.TextCtrl( self, wx.ID_ANY, u"%s"%robotname, wx.DefaultPosition, wx.DefaultSize, style=wx.TE_PROCESS_ENTER)
        self.m_textCtrl1 = wx.TextCtrl( self, wx.ID_ANY, u"%s"%mastername, wx.DefaultPosition, size=wx.Size(80,-1), style=wx.TE_PROCESS_ENTER)
        bSizer4.Add( self.m_textCtrl1, 0, wx.ALL, 1 )
        self.m_staticText4 = wx.StaticText( self, wx.ID_ANY, u":", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer4.Add( self.m_staticText4, 0, wx.ALL, 1 )
        self.m_textCtrl2 = wx.TextCtrl( self, wx.ID_ANY, u"11311", wx.DefaultPosition, size=wx.Size(50, -1), style=wx.TE_PROCESS_ENTER )
        bSizer4.Add( self.m_textCtrl2, 0, wx.ALL, 1 )
        self.m_button_set_uri = wx.Button( self, wx.ID_ANY, u"Set", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer4.Add( self.m_button_set_uri, 0, wx.ALL, 1 )
        self.m_button_clipboard = wx.Button( self, wx.ID_ANY, u"To Clipboard", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer4.Add( self.m_button_clipboard, 0, wx.ALL, 1 )
        
        bSizer1.Add( bSizer4, 0, wx.EXPAND, 1 )
        #------------------------
#        robotinfopanel = wx.Panel(self, -1, style=wx.TAB_TRAVERSAL)
        robotinfo = wx.BoxSizer(wx.HORIZONTAL)
        self.st_robotname = wx.StaticText( self, wx.ID_ANY, u"Robot name", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.robotname = wx.TextCtrl( self, wx.ID_ANY, u"%s"%robotname, wx.DefaultPosition, wx.Size(60,-1), style=wx.TE_PROCESS_ENTER)
        self.st_username = wx.StaticText( self, wx.ID_ANY, u"user", wx.DefaultPosition, wx.Size(40, -1), 0 )
        self.username = wx.TextCtrl( self, wx.ID_ANY, u"%s"%username, wx.DefaultPosition, wx.DefaultSize, style=wx.TE_PROCESS_ENTER)
        self.st_password = wx.StaticText( self, wx.ID_ANY, u"pass", wx.DefaultPosition, wx.Size(40, -1))
        self.password = wx.TextCtrl( self, wx.ID_ANY, u"%s"%passw, wx.DefaultPosition, wx.DefaultSize, style=wx.TE_PASSWORD|wx.TE_PROCESS_ENTER)
#        self.m_button_set_robot = wx.Button( self, wx.ID_ANY, u"Set", wx.DefaultPosition, wx.DefaultSize, 0 )

        self.robotname.MoveAfterInTabOrder(self.username);
        self.username.MoveAfterInTabOrder(self.password);
        self.password.MoveAfterInTabOrder(self.robotname);
#        robotinfopanel.SetSizer(robotinfo)
#        robotinfopanel.SetAutoLayout(True)

        robotinfo.Add( self.st_robotname, 0.5, wx.ALL, 1)
        robotinfo.Add( self.robotname, 1.8, wx.ALL, 1 )
        robotinfo.Add( self.st_username, 0, wx.ALL, 1 )
        robotinfo.Add( self.username, 0, wx.ALL, 1 )
        robotinfo.Add( self.st_password, 0, wx.ALL, 1 )
        robotinfo.Add( self.password, 0, wx.ALL, 1 )
#        robotinfo.Add( self.m_button_set_robot, 0.2, wx.ALL, 5 )

#        bSizer1.Add(robotinfopanel, 1, wx.ALL, 0)
        bSizer1.Add(robotinfo, 0, wx.ALL, 0)
        #------------------------
        self.m_staticline1 = wx.StaticLine( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.LI_HORIZONTAL )
        bSizer1.Add( self.m_staticline1, 0, wx.EXPAND, 1)

    #############launchers##############
        
#        self.m_staticText6 = wx.StaticText( self, wx.ID_ANY, u"Launchers", wx.DefaultPosition, wx.DefaultSize, 0 )
#        self.m_staticText6.Wrap( -1 )
#        bSizer1.Add( self.m_staticText6, 0, wx.ALL, 5 )
        
        #grid = wx.GridSizer( 7, 7, 0, 0 )
        grid = wx.FlexGridSizer( 7, 7, 0, 0 )
        grid.SetFlexibleDirection(wx.HORIZONTAL)
        self.numlaunch = 7
       
        m_choice1Choices = [ u"local", u" robot" ]
        #launcher0
        self.m_check0 = wx.CheckBox( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.Size(10,-1), 0 )
        self.m_check0.SetValue(True) 
        self.m_launcher0 = wx.Button( self, wx.ID_ANY, u"robot",wx.DefaultPosition, wx.Size(80,-1), 0 )
        self.m_pack0 = wx.StaticText( self, wx.ID_ANY, u"nifti_driver_robot", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_view0 = wx.Button( self, wx.ID_ANY, u"view",wx.DefaultPosition, wx.Size(45,-1), 0 )
        self.m_choice0 = wx.Choice( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, m_choice1Choices, 0 )
        self.m_choice0.SetSelection( 1 )
        self.m_launch0 = wx.Button( self, wx.ID_ANY, u"launch", wx.DefaultPosition, wx.Size(55, -1), 0 )
        self.m_kill0 = wx.Button( self, wx.ID_ANY, u"kill", wx.DefaultPosition, wx.Size(45, -1), 0 )
        grid.Add( self.m_check0, 1, wx.ALL, 5 )
        grid.Add( self.m_launcher0, 6, wx.ALL, 5 )
        grid.Add( self.m_pack0, 6, wx.ALL, 5 )
        grid.Add( self.m_view0, 6, wx.ALL, 5 )
        grid.Add( self.m_choice0, 6, wx.ALL, 5 )
        grid.Add( self.m_launch0, 6, wx.ALL, 5 )
        grid.Add( self.m_kill0, 6, wx.ALL, 5 )

        #launcher1
        self.m_check1 = wx.CheckBox( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.Size(10,-1), 0 )
        self.m_check1.SetValue(True) 
        self.m_launcher1 = wx.Button( self, wx.ID_ANY, u"joy_teleop",wx.DefaultPosition, wx.Size(80,-1), 0 )
        self.m_pack1 = wx.StaticText( self, wx.ID_ANY, u"nifti_teleop", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_view1 = wx.Button( self, wx.ID_ANY, u"view",wx.DefaultPosition, wx.Size(45,-1), 0 )
        self.m_choice1 = wx.Choice( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, m_choice1Choices, 0 )
        self.m_choice1.SetSelection( 1 )
        self.m_launch1 = wx.Button( self, wx.ID_ANY, u"launch", wx.DefaultPosition, wx.Size(55, -1), 0 )
        self.m_kill1 = wx.Button( self, wx.ID_ANY, u"kill", wx.DefaultPosition, wx.Size(45, -1), 0 )
        grid.Add( self.m_check1, 1, wx.ALL, 5 )
        grid.Add( self.m_launcher1, 6, wx.ALL, 5 )
        grid.Add( self.m_pack1, 6, wx.ALL, 5 )
        grid.Add( self.m_view1, 6, wx.ALL, 5 )
        grid.Add( self.m_choice1, 6, wx.ALL, 5 )
        grid.Add( self.m_launch1, 6, wx.ALL, 5 )
        grid.Add( self.m_kill1, 6, wx.ALL, 5 )

        #launcher2
        self.m_check2 = wx.CheckBox( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.Size(10,-1), 0 )
        self.m_check2.SetValue(True) 
        self.m_launcher2 = wx.Button( self, wx.ID_ANY, u"laser",wx.DefaultPosition, wx.Size(80,-1), 0 )
        self.m_pack2 = wx.StaticText( self, wx.ID_ANY, u"nifti_drivers_launchers", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_view2 = wx.Button( self, wx.ID_ANY, u"view",wx.DefaultPosition, wx.Size(45,-1), 0 )
        self.m_choice2 = wx.Choice( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, m_choice1Choices, 0 )
        self.m_choice2.SetSelection( 1 )
        self.m_launch2 = wx.Button( self, wx.ID_ANY, u"launch", wx.DefaultPosition, wx.Size(55, -1), 0 )
        self.m_kill2 = wx.Button( self, wx.ID_ANY, u"kill", wx.DefaultPosition, wx.Size(45, -1), 0 )
        grid.Add( self.m_check2, 1, wx.ALL, 5 )
        grid.Add( self.m_launcher2, 6, wx.ALL, 5 )
        grid.Add( self.m_pack2, 6, wx.ALL, 5 )
        grid.Add( self.m_view2, 6, wx.ALL, 5 )
        grid.Add( self.m_choice2, 6, wx.ALL, 5 )
        grid.Add( self.m_launch2, 6, wx.ALL, 5 )
        grid.Add( self.m_kill2, 6, wx.ALL, 5 )


        #launcher3
        self.m_check3 = wx.CheckBox( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.Size(10, -1) )
        self.m_check3.SetValue(True) 
        self.m_launcher3 = wx.Button( self, wx.ID_ANY, u"omnicam",wx.DefaultPosition, wx.Size(80,-1), 0 )
        self.m_pack3 = wx.StaticText( self, wx.ID_ANY, u"nifti_drivers_launchers", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_view3 = wx.Button( self, wx.ID_ANY, u"view",wx.DefaultPosition, wx.Size(45,-1), 0 )
        self.m_choice3 = wx.Choice( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, m_choice1Choices, 0 )
        self.m_choice3.SetSelection( 1 )
        self.m_launch3 = wx.Button( self, wx.ID_ANY, u"launch", wx.DefaultPosition, wx.Size(55, -1), 0 )
        self.m_kill3 = wx.Button( self, wx.ID_ANY, u"kill", wx.DefaultPosition, wx.Size(45, -1), 0 )
        grid.Add( self.m_check3, 1, wx.ALL, 5 )
        grid.Add( self.m_launcher3, 6, wx.ALL, 5 )
        grid.Add( self.m_pack3, 6, wx.ALL, 5 )
        grid.Add( self.m_view3, 6, wx.ALL, 5 )
        grid.Add( self.m_choice3, 6, wx.ALL, 5 )
        grid.Add( self.m_launch3, 6, wx.ALL, 5 )
        grid.Add( self.m_kill3, 6, wx.ALL, 5 )

        #launcher4
        self.m_check4 = wx.CheckBox( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.Size(10,-1), 0 )
        self.m_check4.SetValue(True) 
        self.m_launcher4 = wx.Button( self, wx.ID_ANY, u"imu",wx.DefaultPosition, wx.Size(80,-1), 0 )
        self.m_pack4 = wx.StaticText( self, wx.ID_ANY, u"nifti_drivers_launchers", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_view4 = wx.Button( self, wx.ID_ANY, u"view",wx.DefaultPosition, wx.Size(45,-1), 0 )
        self.m_choice4 = wx.Choice( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, m_choice1Choices, 0 )
        self.m_choice4.SetSelection( 1 )
        self.m_launch4 = wx.Button( self, wx.ID_ANY, u"launch", wx.DefaultPosition, wx.Size(55, -1), 0 )
        self.m_kill4 = wx.Button( self, wx.ID_ANY, u"kill", wx.DefaultPosition, wx.Size(45, -1), 0 )
        grid.Add( self.m_check4, 1, wx.ALL, 5 )
        grid.Add( self.m_launcher4, 6, wx.ALL, 5 )
        grid.Add( self.m_pack4, 6, wx.ALL, 5 )
        grid.Add( self.m_view4, 6, wx.ALL, 5 )
        grid.Add( self.m_choice4, 6, wx.ALL, 5 )
        grid.Add( self.m_launch4, 6, wx.ALL, 5 )
        grid.Add( self.m_kill4, 6, wx.ALL, 5 )

        #launcher5
        self.m_check5 = wx.CheckBox( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.Size(10,-1), 0 )
        self.m_check5.SetValue(True) 
        self.m_launcher5 = wx.Button( self, wx.ID_ANY, u"...",wx.DefaultPosition, wx.Size(80,-1), 0 )
        self.m_pack5 = wx.StaticText( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_view5 = wx.Button( self, wx.ID_ANY, u"view",wx.DefaultPosition, wx.Size(45,-1), 0 )
        self.m_choice5 = wx.Choice( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, m_choice1Choices, 0 )
        self.m_choice5.SetSelection( 1 )
        self.m_launch5 = wx.Button( self, wx.ID_ANY, u"launch", wx.DefaultPosition, wx.Size(55, -1), 0 )
        self.m_kill5 = wx.Button( self, wx.ID_ANY, u"kill", wx.DefaultPosition, wx.Size(45, -1), 0 )
        grid.Add( self.m_check5, 1, wx.ALL, 5 )
        grid.Add( self.m_launcher5, 6, wx.ALL, 5 )
        grid.Add( self.m_pack5, 6, wx.ALL, 5 )
        grid.Add( self.m_view5, 6, wx.ALL, 5 )
        grid.Add( self.m_choice5, 6, wx.ALL, 5 )
        grid.Add( self.m_launch5, 6, wx.ALL, 5 )
        grid.Add( self.m_kill5, 6, wx.ALL, 5 )

        #launcher6
        self.m_check6 = wx.CheckBox( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.Size(10,-1), 0 )
        self.m_check6.SetValue(True) 
        self.m_launcher6 = wx.Button( self, wx.ID_ANY, u"...",wx.DefaultPosition, wx.Size(80,-1), 0 )
        self.m_pack6 = wx.StaticText( self, wx.ID_ANY, u"", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_view6 = wx.Button( self, wx.ID_ANY, u"view",wx.DefaultPosition, wx.Size(45,-1), 0 )
        self.m_choice6 = wx.Choice( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, m_choice1Choices, 0 )
        self.m_choice6.SetSelection( 1 )
        self.m_launch6 = wx.Button( self, wx.ID_ANY, u"launch", wx.DefaultPosition, wx.Size(55, -1), 0 )
        self.m_kill6 = wx.Button( self, wx.ID_ANY, u"kill", wx.DefaultPosition, wx.Size(45, -1), 0 )
        grid.Add( self.m_check6, 1, wx.ALL, 5 )
        grid.Add( self.m_launcher6, 6, wx.ALL, 5 )
        grid.Add( self.m_pack6, 6, wx.ALL, 5 )
        grid.Add( self.m_view6, 6, wx.ALL, 5 )
        grid.Add( self.m_choice6, 6, wx.ALL, 5 )
        grid.Add( self.m_launch6, 6, wx.ALL, 5 )
        grid.Add( self.m_kill6, 6, wx.ALL, 5 )

        #lists
        self.list_launcher_check = [self.m_check0, self.m_check1, self.m_check2, self.m_check3, self.m_check4, self.m_check5, self.m_check6 ]
        self.list_file_button= [self.m_launcher0, self.m_launcher1,self.m_launcher2,self.m_launcher3,self.m_launcher4,self.m_launcher5,self.m_launcher6]
        self.list_packs = [self.m_pack0, self.m_pack1,self.m_pack2,self.m_pack3,self.m_pack4,self.m_pack5,self.m_pack6]
        self.list_file_view= [self.m_view0, self.m_view1, self.m_view2, self.m_view3, self.m_view4, self.m_view5, self.m_view6 ]
        self.list_choice= [self.m_choice0, self.m_choice1, self.m_choice2, self.m_choice3, self.m_choice4, self.m_choice5, self.m_choice6]
        self.list_launch_button= [self.m_launch0, self.m_launch1, self.m_launch2, self.m_launch3, self.m_launch4, self.m_launch5, self.m_launch6 ]
        self.list_kill_button=[self.m_kill0, self.m_kill1, self.m_kill2, self.m_kill3, self.m_kill4, self.m_kill5, self.m_kill6 ]
        #launchers init

        self.list_nodes_contained_in_launchers = [[],[],[],[],[],[],[]] #7 empty
        self.list_newlaunchers = ["","","","","","",""]

        if os.path.exists(logfile):
            self.loadstates()
        else:
            self.list_launchfile = [("nifti_drivers_launchers", "robot.launch"), 
                                    ("nifti_teleop", "teleop_joy.launch"),
                                    ("nifti_drivers_launchers", "laser.launch"),
                                    ("nifti_drivers_launchers", "omnicamera.launch"),
                                    ("nifti_drivers_launchers", "imu.launch")]
            for i in range(self.numlaunch - len(self.list_launchfile)):
                self.list_launchfile.append(("", ""))
            self.valid_launcher=[0, 1, 2, 3, 4]

        self.list_launchfilepath=[]
        for i in range(self.numlaunch):
            #self.list_kill_button[i].Disable()
            self.list_launchfilepath.append( self.get_filepath(i) )

        for i in range( self.numlaunch ):
            if i not in self.valid_launcher:
                self.list_nodes_contained_in_launchers[i] = []
                #status
                self.list_launcher_check[i].Disable()
                self.list_file_view[i].Disable()
                self.list_choice[i].Disable()
                self.list_launch_button[i].Disable()
            else:
                self.list_nodes_contained_in_launchers[i] =self.get_nodes_from_launchfile( self.list_launchfilepath[i] )
                self.list_launcher_check[i].Enable()
                self.list_file_view[i].Enable()
                self.list_choice[i].Enable()
                self.list_launch_button[i].Enable()

        #launch them all (ticked)
        self.m_button11 = wx.Button( self, wx.ID_ANY, u"Launch selected", wx.DefaultPosition, wx.DefaultSize, 0 )

        bSizer1.Add( grid, 0, wx.EXPAND, 5 )
        bSizer1.Add( self.m_button11, 0, wx.ALL, 5 )

        
    
        #add to layout - left frame (Workspace)
        self.Workspace.Add( bSizer1, 0, wx.EXPAND, 2 )
        
        self.gSizer1.Add( self.Workspace, 0.7, wx.EXPAND, 5 ) 




####################################################
        
        self.Obser = wx.BoxSizer(wx.VERTICAL)


        self.Nodes = wx.StaticBoxSizer( wx.StaticBox( self, wx.ID_MS, u"Nodes" ), wx.VERTICAL  )
        nodeSizer = wx.BoxSizer(wx.HORIZONTAL)
        #left -> list
        self.nodechecklist = CheckListCtrl(self)
        self.nodechecklist.InsertColumn(0, '(k) Node', width=140)
        self.nodechecklist.InsertColumn(1, 'where', width=100)
        nodeSizer.Add(self.nodechecklist, 3, wx.EXPAND, 2)
        #right -> buttons
        nodesbuttons = wx.BoxSizer(wx.VERTICAL)
        self.nodes_refresh = wx.Button( self, wx.ID_ANY, u"refresh", wx.DefaultPosition, wx.Size(80, -1), 0 )
        self.nodes_ping = wx.ToggleButton( self, wx.ID_ANY, u"ping", wx.DefaultPosition, wx.Size(80, -1), 0 )
        self.nodes_info = wx.Button( self, wx.ID_ANY, u"info", wx.DefaultPosition, wx.Size(80, -1), 0 )
        self.nodes_kill= wx.Button( self, wx.ID_ANY, u"kill ticked", wx.DefaultPosition, wx.Size(80, -1), 0 )
        self.nodes_killall= wx.Button( self, wx.ID_ANY, u"kill all", wx.DefaultPosition, wx.Size(80, -1), 0 )
        nodesbuttons.Add(self.nodes_refresh , 1, wx.EXPAND, 5)
        nodesbuttons.Add(self.nodes_ping , 1, wx.EXPAND, 5)
        nodesbuttons.Add(self.nodes_info , 1, wx.EXPAND, 5)
        nodesbuttons.Add(self.nodes_kill , 1, wx.EXPAND, 5)
        nodesbuttons.Add(self.nodes_killall , 1, wx.EXPAND, 5)
        nodeSizer.Add(nodesbuttons, 1, wx.EXPAND, 2)
        self.Nodes.Add(nodeSizer, 1, wx.EXPAND, 5)


        self.Topics = wx.StaticBoxSizer( wx.StaticBox( self, wx.ID_MS, u"Topics" ), wx.VERTICAL  )
        topicSizer = wx.BoxSizer(wx.HORIZONTAL)
        #left -> list
        self.topicchecklist = wx.ListBox(self, 20, (-1, -1), (-1, -1), self.list_of_topics, wx.LB_HSCROLL)
        topicSizer.Add(self.topicchecklist, 3, wx.EXPAND, 5)
        #right -> buttons
        topicsbuttons = wx.BoxSizer(wx.VERTICAL)
        self.topics_refresh = wx.Button( self, wx.ID_ANY, u"refresh", wx.DefaultPosition, wx.Size(80, -1), 0 )
        self.topics_echo = wx.ToggleButton( self, wx.ID_ANY, u"echo", wx.DefaultPosition, wx.Size(80, -1), 0 )
        self.topics_hz = wx.ToggleButton( self, wx.ID_ANY, u"hz", wx.DefaultPosition, wx.Size(80, -1), 0 )
        self.topics_info = wx.Button( self, wx.ID_ANY, u"info", wx.DefaultPosition, wx.Size(80, -1), 0 )
        topicsbuttons.Add(self.topics_refresh , 1, wx.EXPAND, 5)
        topicsbuttons.Add(self.topics_echo , 1, wx.EXPAND, 5)
        topicsbuttons.Add(self.topics_hz , 1, wx.EXPAND, 5)
        topicsbuttons.Add(self.topics_info , 1, wx.EXPAND, 5)
        topicSizer.Add(topicsbuttons, 1, wx.EXPAND, 5)
        self.Topics.Add(topicSizer, 1, wx.EXPAND, 5)


        self.Misc = wx.BoxSizer(wx.VERTICAL)
#------------------------
        #other commands
        bSizer_cmd = wx.BoxSizer( wx.HORIZONTAL )
        self.m_textCtrl_cmd = wx.TextCtrl( self, wx.ID_ANY, size=wx.Size(220,-1), style=wx.TE_PROCESS_ENTER)
        bSizer_cmd.Add(self.m_textCtrl_cmd, 0, wx.ALL, 1) # 1 is boarder
        self.m_button_cmd = wx.Button( self, wx.ID_ANY, u"Run", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer_cmd.Add( self.m_button_cmd, 0, wx.ALL, 1 )
        self.m_button_cmd_clear = wx.Button( self, wx.ID_ANY, u"Clear", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer_cmd.Add( self.m_button_cmd_clear, 0, wx.ALL, 1 )
        self.Misc.Add( bSizer_cmd, 1, wx.EXPAND, 0 )
#------------------------
        bSizer7 = wx.BoxSizer( wx.HORIZONTAL )
        self.m_textCtrl5 = wx.TextCtrl( self, wx.ID_ANY, size=(180,-1), style=wx.TE_PROCESS_ENTER)
        bSizer7.Add( self.m_textCtrl5, 0, wx.ALL, 2 )
        self.m_textCtrl6 = wx.TextCtrl( self, wx.ID_ANY,  u"compressed", wx.DefaultPosition, wx.Size(80,-1), style=wx.TE_PROCESS_ENTER )
        bSizer7.Add( self.m_textCtrl6, 0, wx.ALL, 2 )
        self.m_button_image_view = wx.Button( self, wx.ID_ANY, u"image_view", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer7.Add( self.m_button_image_view, 0, wx.ALL, 2 )
        self.Misc.Add( bSizer7, 1, wx.EXPAND, 0 )

        bSizert = wx.BoxSizer( wx.HORIZONTAL )
        self.m_tf1 = wx.TextCtrl( self, wx.ID_ANY, size=(100,-1))
        bSizert.Add( self.m_tf1, 0, wx.ALL, 2 )
        self.m_tf2 = wx.TextCtrl( self, wx.ID_ANY,  u"/map", wx.DefaultPosition, wx.Size(80,-1))
        bSizert.Add( self.m_tf2, 0, wx.ALL, 2 )
        self.m_button_tfecho= wx.ToggleButton( self, wx.ID_ANY, u"tf_echo", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizert.Add( self.m_button_tfecho, 0, wx.ALL, 2 )
        self.m_button_tf_monitor = wx.ToggleButton( self, wx.ID_ANY, u"tf_monitor", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizert.Add( self.m_button_tf_monitor, 0, wx.ALL, 2 )
        self.Misc.Add( bSizert, 1, wx.EXPAND, 0 )

        self.m_textCtrl5.MoveAfterInTabOrder(self.m_textCtrl6);
        self.m_textCtrl6.MoveAfterInTabOrder(self.m_textCtrl5);
        self.m_tf1.MoveAfterInTabOrder(self.m_tf2);
        self.m_tf2.MoveAfterInTabOrder(self.m_tf1);
#--------------------------
        bSizer9 = wx.BoxSizer( wx.HORIZONTAL)
        bSizer9.AddSpacer( ( 0, 10), 1, wx.EXPAND, 5 )
        self.m_button_rxconsole= wx.Button( self, wx.ID_ANY, u"rxconsole", wx.DefaultPosition, wx.DefaultSize, 0 )
        self.m_button_monitor= wx.Button( self, wx.ID_ANY, u"monitor", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer9.Add( self.m_button_monitor, 0, wx.ALL, 5 )
        bSizer9.Add( self.m_button_rxconsole, 0, wx.ALL, 5 )
        self.m_button_rxgraph = wx.Button( self, wx.ID_ANY, u"rxgraph", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer9.Add( self.m_button_rxgraph, 0, wx.ALL, 5 )
        self.m_button_roswtf = wx.Button( self, wx.ID_ANY, u"roswtf", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer9.Add( self.m_button_roswtf, 0, wx.ALL, 5 )
        self.m_button_run_rviz = wx.Button( self, wx.ID_ANY, u"Run rviz", wx.DefaultPosition, wx.DefaultSize, 0 )
        bSizer9.Add( self.m_button_run_rviz, 0, wx.ALL, 5 )
#        self.m_staticline2 = wx.StaticLine( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.LI_HORIZONTAL )
#        bSizer9.Add( self.m_staticline2, 0, wx.EXPAND |wx.ALL, 5 )
#        self.m_staticline3 = wx.StaticLine( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.LI_HORIZONTAL )
#        bSizer9.Add( self.m_staticline3, 0, wx.EXPAND |wx.ALL, 5 )
        self.Misc.Add(bSizer9, 1, wx.ALL, 0)


        self.Obser.Add(self.Nodes, 1, wx.EXPAND, 0)
        self.Obser.Add(self.Topics, 1, wx.EXPAND, 0)
        self.Obser.Add(self.Misc,0.2, wx.ALL, 0)

        self.gSizer1.Add(self.Obser, 1, wx.EXPAND,5)
##############End 

        self.SetSizer( self.gSizer1 )
        self.gSizer1.Fit( self )
        self.SetMinSize(self.gSizer1.GetMinSize())
        self.Layout()
        
        self.Centre( )
        
        #
        # Connect Events
        #
        #roscore related
        self.m_button_start_roscore.Bind( wx.EVT_BUTTON, self.onStartRoscore )
        self.m_button_kill_roscore.Bind( wx.EVT_BUTTON, self.onKillRoscore )
        self.m_button_ping_host.Bind( wx.EVT_TOGGLEBUTTON, self.onPingHost)
        self.m_kill_everything.Bind( wx.EVT_BUTTON, self.onKillEverything)
        self.m_button_set_uri.Bind( wx.EVT_BUTTON, self.onSetURI )
        self.m_button_clipboard.Bind( wx.EVT_BUTTON, self.onClipboard)
        self.m_textCtrl1.Bind( wx.EVT_TEXT_ENTER, self.onSetURI)
        self.m_textCtrl2.Bind( wx.EVT_TEXT_ENTER, self.onSetURI)

        #robot related
#        self.m_button_set_robot.Bind( wx.EVT_BUTTON, self.onSetRobot)
        self.robotname.Bind( wx.EVT_TEXT, self.onSetRobot)
        self.username.Bind( wx.EVT_TEXT, self.onSetRobot)
        self.password.Bind( wx.EVT_TEXT, self.onSetRobot)

        #launchers
        for i, item in enumerate(self.list_file_button):
            item.Bind(wx.EVT_BUTTON, lambda evt, index=i : self.launcher_browse(evt, index))
        for i, item in enumerate(self.list_file_view):
            item.Bind(wx.EVT_BUTTON, lambda evt, index=i : self.launcher_view(evt, index))
        for i, item in enumerate(self.list_launch_button):
            item.Bind(wx.EVT_BUTTON, lambda evt, index=i : self.launcher_callback(evt, index))
        for i, item in enumerate(self.list_kill_button):
            item.Bind(wx.EVT_BUTTON, lambda evt, index=i : self.launcher_kill(evt, index))
        self.m_button11.Bind( wx.EVT_BUTTON, self.onLaunchSelected )
            
        #run command
        self.m_textCtrl_cmd.Bind( wx.EVT_TEXT_ENTER, self.onCmdRun)
        self.m_button_cmd.Bind( wx.EVT_BUTTON, self.onCmdRun )
        self.m_button_cmd_clear.Bind( wx.EVT_BUTTON, self.onCmdRunClear )
        self.m_button_tf_monitor.Bind( wx.EVT_TOGGLEBUTTON, self.onTfMonitor)

        #rostopic
        self.topics_refresh.Bind( wx.EVT_BUTTON, self.onRostopicList )
        self.topics_echo.Bind( wx.EVT_TOGGLEBUTTON, self.onRostopicEcho )
        self.topics_hz.Bind( wx.EVT_TOGGLEBUTTON, self.onRostopicHz )
        self.topics_info.Bind( wx.EVT_BUTTON, self.onRostopicInfo )

        #rosnode
        self.nodes_refresh.Bind( wx.EVT_BUTTON, self.onRosnodeList )
        self.nodes_ping.Bind( wx.EVT_TOGGLEBUTTON, self.onRosnodePing )
        self.nodes_info.Bind( wx.EVT_BUTTON, self.onRosnodeInfo )
        self.nodes_kill.Bind( wx.EVT_BUTTON, self.onRosnodeKill)
        self.nodes_killall.Bind( wx.EVT_BUTTON, self.onRosnodeKillAll)

        #image_view
        #drag
        self.Bind(wx.EVT_LISTBOX, self.onDragInit, id=self.topicchecklist.GetId())
        self.m_button_image_view.Bind( wx.EVT_BUTTON, self.onImageView )
        self.m_textCtrl5.Bind( wx.EVT_TEXT_ENTER, self.onImageView)
        self.m_textCtrl6.Bind( wx.EVT_TEXT_ENTER, self.onImageView)
        self.m_button_tfecho.Bind( wx.EVT_TOGGLEBUTTON, self.onTfEcho)
        self.m_tf1.Bind( wx.EVT_TEXT_ENTER, self.onTfEcho)
        self.m_tf2.Bind( wx.EVT_TEXT_ENTER, self.onTfEcho)

        #other miscs
        self.m_button_monitor.Bind( wx.EVT_BUTTON, self.onMonitor)
        self.m_button_rxconsole.Bind( wx.EVT_BUTTON, self.onRxconsole)
        self.m_button_rxgraph.Bind( wx.EVT_BUTTON, self.onRxgraph )
        self.m_button_roswtf.Bind( wx.EVT_BUTTON, self.onRoswtf )
        self.m_button_run_rviz.Bind( wx.EVT_BUTTON, self.onRunRviz )
        self.m_button_quit.Bind( wx.EVT_BUTTON, self.onQuit )
#        self.m_button_nodes.Bind( wx.EVT_TOGGLEBUTTON, self.onNodesView)
        self.m_button_shutoff_robot.Bind( wx.EVT_BUTTON, self.onShutoffRobot)


        #
        #Quit program
        #
        self.Bind(wx.EVT_CLOSE, self.onCloseWindow)
        self.m_button_set_uri.Bind(wx.EVT_KEY_DOWN, self.onKeys)
        self.m_button_run_rviz.Bind(wx.EVT_KEY_DOWN, self.onKeys)
        self.m_button_start_roscore.Bind(wx.EVT_KEY_DOWN, self.onKeys)
        self.m_button_cmd.Bind(wx.EVT_KEY_DOWN, self.onKeys)

        self.topics_refresh.Bind(wx.EVT_KEY_DOWN, self.onKeys)
        self.nodes_refresh.Bind(wx.EVT_KEY_DOWN, self.onKeys)
        self.m_button_image_view.Bind(wx.EVT_KEY_DOWN, self.onKeys)

#        self.Bind(wx.EVT_SIZE, self.onSize)
#        self.Bind(wx.EVT_MOVE, self.onMove)

        self.m_checkBox_check_roscore.Bind(wx.EVT_CHECKBOX, self.set_checker)


        #status bar
        self.CreateStatusBar()


        #set roscore observer
        #self.th = threading.Thread(target=self.roscore_checker, args=())
        #self.th.start()

        #pubsub receiver
        Publisher().subscribe(self.updateLED, "status")

        #two images
        img_file = os.path.abspath(__file__)
        img_file = os.path.dirname(img_file)
        red_file = os.path.join(img_file, "red.png")
        green_file = os.path.join(img_file, "green.png")
        orange_file = os.path.join(img_file, "orange.png")
        self.img_error = wx.Image(red_file, wx.BITMAP_TYPE_PNG)
        self.img_normal= wx.Image(orange_file, wx.BITMAP_TYPE_PNG)
        self.img_running= wx.Image(green_file, wx.BITMAP_TYPE_PNG)
        self.m_bitmap1.SetBitmap(wx.BitmapFromImage(self.img_normal))


        #pid parameters
        self.pid_nodeping = None
        self.pid_topicecho = None
        self.pid_topichz = None
        self.pid_tfmonitor = None
        self.pid_tfecho = None

        #show current setup
        f=os.popen("echo $ROS_MASTER_URI")
        txt = f.readline()
        self.SetStatusText("\nCurrent ROS_MASTER_URI: "+txt)


    def set_checker(self, event):
        check_roscore_thread(self)

    
    def __del__( self ):
        pass
   

    def updateLED(self, msg):
        st = msg.data
        if st == 1:
            self.setError()
        elif st == 0:
            self.setRunning()
        elif st == -1:
            self.setNormal()
                


    #status of LED
    def setError(self):
        if self.roscore_ledstatus != 1: #error status
            self.m_bitmap1.SetBitmap(wx.BitmapFromImage(self.img_error))
            self.Refresh()
            f=os.popen("echo $ROS_MASTER_URI")
            txt = f.readline()
            self.SetStatusText("\nroscore is DEAD!"+" Current MASTER is "+txt)
            self.roscore_ledstatus = 1


    def setNormal(self):
        if self.roscore_ledstatus != -1: #normal status: not observed
            self.m_bitmap1.SetBitmap(wx.BitmapFromImage(self.img_normal))
            self.Refresh()
            f=os.popen("echo $ROS_MASTER_URI")
            txt = f.readline()
            self.SetStatusText("\nPlease tick the obs. Roscore to observe status."+" Current MASTER is "+txt)
            self.roscore_ledstatus = -1

    def setRunning(self):
        if self.roscore_ledstatus != 0: #running status
            self.m_bitmap1.SetBitmap(wx.BitmapFromImage(self.img_running))
            self.Refresh()
            f=os.popen("echo $ROS_MASTER_URI")
            txt = f.readline()
            self.SetStatusText("\nroscore is OK!"+" Current MASTER is "+txt)
            self.roscore_ledstatus = 0
    
    # event handlers
    def onStartRoscoreLocal( self ):
        os.system("roscore &")
        self.setNormal()

    def onStartRoscoreRemote( self ):
        start_roscore_robot('%s'%passw)
        print "roscore started. Try to observe the status please. launch_remote_core set to %d"%launch_remote_core
        self.setNormal()

    def onStartRoscore(self, event):
        master = os.environ["ROS_MASTER_URI"]
        if master.find('localhost') == -1: #not there
            self.onStartRoscoreRemote()
        else:
            self.onStartRoscoreLocal()
        event.Skip()

    def onKillRoscoreLocal( self ):
        print "RUN: kill -9 $(ps ax | grep -v grep | egrep rosmaster\|roscore\|rosout | awk '{print $1}') "
        os.system(r"kill -9 $(ps ax | grep -v grep | egrep rosmaster\|roscore\|rosout | awk '{print $1}')")
        self.setNormal()

    def onKillRoscoreRemote( self ):
        kill_roscore_robot('%s'%passw)
        print "roscore killed. Try to observe the status please."
        launch_remote_core = False
        self.setNormal()

    def onKillRoscore(self, event):
        master = os.environ["ROS_MASTER_URI"]
        if master.find('localhost') == -1: #not there
            self.onKillRoscoreRemote()
        else:
            self.onKillRoscoreLocal()
        event.Skip()

    def onPingHost( self, event ):
        topicname=self.m_textCtrl1.GetValue().encode('ascii', 'ignore')
        cmd = "ping %s"%topicname
        if self.m_button_ping_host.GetValue():
            args = shlex.split(cmd)
            self.pid_pinghost= subprocess.Popen(args) 
        else:
            self.pid_pinghost.kill()
            self.pid_pinghost.wait()
            print "Ping host Terminated. "
        event.Skip()

    def onKillEverythingLocal( self ):
        os.system(r"kill -9 $(ps ax | grep -v grep | egrep ros | awk '{print $1}')")
        self.setNormal()

    def onKillEverythingRemote( self ):
        kill_everything_robot('%s'%passw)
        print "Everything on [%s] related to ros are killed"%robotname
        launch_remote_core = False
        self.setNormal()

    def onKillEverything(self, event):
        dial = wx.MessageDialog(None, 'This button will kill everything that is related to ROS on MASTER_URI. Continue?', 'Question', 
        wx.YES_NO | wx.NO_DEFAULT | wx.ICON_EXCLAMATION)
        if (dial.ShowModal() == wx.ID_YES):
            print "Killing everything... "
            master = os.environ["ROS_MASTER_URI"]
            if master.find('localhost') == -1: #not there
                self.onKillEverythingRemote()
            else:
                self.onKillEverythingLocal()
        event.Skip()
        
   
    def onClipboard(self, event):
        s="export ROS_MASTER_URI=http://%s:%s"%(self.m_textCtrl1.GetValue().encode('ascii', 'ignore'),self.m_textCtrl2.GetValue().encode('ascii', 'ignore') )
        clipboard.set_text(s)
        self.SetStatusText("\n\'%s\' has been set to clipboard. \n "%s)
        event.Skip()

    def onSetURI( self, event ):
        global robotname
        hostname = self.m_textCtrl1.GetValue().encode('ascii', 'ignore')
        robotname = hostname
        port = self.m_textCtrl2.GetValue().encode('ascii', 'ignore')
        cmd = "export ROS_MASTER_URI=http://%s:%s"%(hostname, port)
        print cmd
        os.environ["ROS_MASTER_URI"] = "http://%s:%s"%(hostname, port)

        f=os.popen("echo $ROS_MASTER_URI")
        txt = f.readline()
        self.SetStatusText("\nCurrent ROS_MASTER_URI: "+txt)
        event.Skip()

    def onSetRobot( self, event ):
        global robotname
        global username
        global passw
        robotname = self.robotname.GetValue()
        username = self.username.GetValue()
        passw = self.password.GetValue()
        event.Skip()

    def launcher_browse(self, event, index):
        #browser
        dlg = wx.FileDialog(self, "Open a launcher", style=wx.FD_OPEN)
        wildcard = "ROS Launch Files (.launch)|*.launch|"\
                   "XML Launch Files (.xml)|*.xml|"\
                   "All files (*.*)|*.*"
        dlg.SetWildcard(wildcard)

        fname = ""
        self.user_launcher_path = ""
        if dlg.ShowModal() == wx.ID_OK:
            self.user_launcher_path = dlg.GetPath()
            fname = dlg.GetFilename()
        else:
            #nothing selected
            dlg.Destroy()
            return
        dlg.Destroy()
        #detect which package is the file
        packagename = locate_package_of_file(self.user_launcher_path)

        if packagename is "" or fname is "":
            self.list_file_button[index].SetLabel("...")
            self.list_packs[index].SetLabel("")
            self.list_launcher_check[index].Disable()
            self.list_file_view[index].Disable()
            self.list_choice[index].Disable()
            self.list_launch_button[index].Disable()
            self.list_kill_button[index].Disable()
            return
            
        #change label on button
        self.list_file_button[index].SetLabel("%s"%fname)
        self.list_packs[index].SetLabel("%s"%packagename)
        #enable nodes button
        self.list_file_view[index].Enable()
        self.list_choice[index].Enable()
        self.list_launcher_check[index].Enable()
        self.list_launch_button[index].Enable()

        #update the launch file list
        self.list_launchfile[index]=(packagename, fname)
        self.list_launchfilepath[index]=self.get_filepath(index)
        self.list_nodes_contained_in_launchers[index] = self.get_nodes_from_launchfile( self.list_launchfilepath[index] )

        event.Skip()

    def launcher_view( self, event, index ):
        #use separate window, read only
        textdlg = TextFrame(self, -1 )
        launcher = self.list_launchfilepath[index]
        text = open("%s"%launcher, "r").read()
#textctrl
        #textdlg.m_textCtrl1.SetValue(text)
#STC
        textdlg.m_textCtrl1.SetText(text)
        res = textdlg.ShowModal()
        textdlg.Destroy()

        #use ros tools directly
        #os.environ["EDITOR"]="gvim"
        #os.system("source %s/tools/rosbash/rosbash"%os.environ["ROS_ROOT"])
        #os.system("rosed %s %s"%(self.list_launchfile[index][0], self.list_launchfile[index][1]))
        event.Skip()


    def get_filepath(self, index):
        p = ""
        item = self.list_launchfile[index]
        if item[0] is not "" and item[1] is not "":
            #get directory
            try:
                path = os.popen("rospack find %s"%item[0]).read().rsplit()[0]
                p = os.popen("find %s -name %s"%(path, item[1])).read().rsplit()[0]
            except:
                pass
            if p is "":
                wx.MessageBox("The file is missing during this time! Please manually check it.", "Warn")
        return p

   
    def get_nodes_from_launchfile(self, filename):
        if filename is "":
            return []
        try:
            tree = ET.parse(filename)
        except Exception, inst:
            print "Unexpected error in opening %s: %s"%(filename, inst)
            return

        eles = tree.findall('node')
        nodelist = [n.get('name') for n in eles]
        return nodelist   

    def create_remote_launchfile(self, infile, outfile):
        """
            create launch file fit for remote start
        """
        try:
            tree = ET.parse(infile)
        except Exception, inst:
            print "Unexpected error in opening %s: %s"%(infile, inst)
            return False

        print "Creating locally remote launch file in /tmp..."
        child = ET.Element("machine")
        child.set("name", "robot")
        child.set("address", robotname)
        child.set("default", "true")

        if not self.LaunchedOnce:
            #show message box asking if want to load remote variable
            dial = wx.MessageDialog(None, 'Do you want to re-load remote ROS_ROOT and ROS_PACKAGE_PATH? \n Current setup:\n ROS_ROOT=%s\n ROS_PACKAGE_PATH=%s'%(self.remote_ros_root, self.remote_package_path), 'Question', 
            wx.YES_NO | wx.NO_DEFAULT | wx.ICON_QUESTION)
            if (dial.ShowModal() == wx.ID_YES):
                ps=pxssh.pxssh()
                if ps.login(robotname, username, passw):
                    print "SSH link established"

                    ps.sendline('echo $ROS_ROOT')
                    ps.prompt()
                    troot=ps.before
                    ttroot = troot.splitlines()
                    troot = ttroot[1]
                    print "Remote $ROS_ROOT is ", troot

                    ps.sendline('echo $ROS_PACKAGE_PATH')
                    ps.prompt()
                    tpkg=ps.before
                    ttpkg = tpkg.splitlines()
                    tpkg = ttpkg[1]
                    print "Remote $ROS_PACKAGE_PATH is ", tpkg

                    ps.close()
                else:
                    dial = wx.MessageDialog(None, 'Can not connect to the robot .\n Please check the connection.', 'Failed!', 
                            wx.ICON_ERROR)
                    dial.ShowModal()
                    dial.Destroy()
                    return False

                self.remote_ros_root = troot
                self.remote_package_path = tpkg

                self.LaunchedOnce = True

            dial.Destroy()

        child.set("ros-package-path", self.remote_package_path )
        child.set("ros-root", self.remote_ros_root )
        child.set("user", username)
        child.set("password", passw)
        rootele = tree.getroot()
        rootele.insert(0, child)
        tree.write(outfile)
        return True


    def launcher_callback(self, event, index):
        cmd = ""
        if self.list_choice[index].GetSelection()==0: # local
            print "launch %s locally"%self.list_launchfile[index][1]
            cmd = ("roslaunch %s %s "%(self.list_launchfile[index][0],self.list_launchfile[index][1])).encode('utf-8')
        elif self.list_choice[index].GetSelection()==1: # on robot
            print "launch %s remotely"%self.list_launchfile[index][1]
            filepath = self.list_launchfilepath[index]
            newname = "/tmp/%s_%s_robot.launch"%(self.list_launchfile[index][0], self.list_launchfile[index][1])
            if self.create_remote_launchfile(filepath, newname):
                print "temporary launch file created: %s"%newname
            else:
                return
            self.list_newlaunchers[index] = newname
            cmd = ("roslaunch %s "%newname).encode('utf-8')

        print cmd
        args = shlex.split(cmd)
        self.pid_launcher[index] = subprocess.Popen(args)

        #enable kill button
        self.list_kill_button[index].Enable()
        self.list_choice[index].Disable()
        event.Skip()


    def get_selected_launchers(self):
        checks = []
        for i, m in enumerate(self.list_launcher_check):
            if m.GetValue():
                checks.append(i)
        return checks
        
    def onLaunchSelected( self, event ):
        self.savestates()
        checks = self.get_selected_launchers()
        print checks
        print "Hint: Please make sure the target machine is correctly selected from the droplist!"
        for c in checks:
            self.launch_callback(event, c) #launch them
        event.Skip()

    def launcher_kill(self, event, index):
#        nodes = self.list_nodes_contained_in_launchers[index]
#        for n in nodes:
#            os.system("rosnode kill %s &"%n)
#        if self.list_choice[index].GetSelection() == 1:
#            os.system(r"kill -9 $(ps ax | grep -v grep | egrep %s| awk '{print $1}')"%self.list_newlaunchers[index])
#        else:
#            print "RUN: kill -9 $(ps ax | grep -v grep | egrep %s| awk '{print $1}')"%self.list_launchfile[index][1]
#            os.system(r"kill -9 $(ps ax | grep -v grep | egrep %s| awk '{print $1}')"%self.list_launchfile[index][1])

#        debug_here()
        print "Killing index; %d"%index
        if not hasattr(self.pid_launcher[index], 'terminate'):
            dial = wx.MessageDialog(None, 'I can only kill launchers started in this session.\n Please use the "kill ticked" button on the right.', 'Failed!', 
                wx.ICON_ERROR)
            dial.ShowModal()
            return
            
        self.pid_launcher[index].terminate()
        self.pid_launcher[index].wait()
        print "Launcher %d Terminated. "%index

        #self.list_kill_button[index].Disable()
        self.list_kill_button[index].Enable()
        self.list_choice[index].Enable()

    def onUserLaunch(self, event):
        os.system("roslaunch %s &"%self.user_launcher_path) 
        event.Skip()

    def onUserLaunchBrowser(self, event):
        #browser
        dlg = wx.FileDialog(self, "Open a launcher", style=wx.FD_OPEN)
        wildcard = "ROS Launch Files (.launch)|*.launch|"\
                   "XML Launch Files (.xml)|*.xml|"\
                   "All files (*.*)|*.*"
        dlg.SetWildcard(wildcard)
        
        fname = ""
        if dlg.ShowModal() == wx.ID_OK:
            self.user_launcher_path = dlg.GetPath()
            fname = dlg.GetFilename()
        dlg.Destroy()
        #change label on button
        self.m_button_user_launcher.SetLabel("%s"%fname)
        #enable nodes button
        self.m_button_user_nodes.Enable()
        event.Skip()
    
#    def onNodes2( self, event ):
#        l = get_nodes_from_launchfile(launchfiles_on_robot[1])
#        dlg = wx.SingleChoiceDialog(None, "Nodes contained:", "List of nodes", l)
#        if dlg.ShowModal() == wx.ID_OK:
#            selection = dlg.GetStringSelection()
#            self.m_textCtrl4.SetValue(selection)
#        dlg.Destroy()
#        event.Skip()
#
    
    def onCmdRun(self, event):
        os.system("%s &"%self.m_textCtrl_cmd.GetValue())
        event.Skip()

    def onCmdRunClear(self, event):
        self.m_textCtrl_cmd.SetValue("")
        event.Skip()

            

        
    
#    def onRostopicList( self, event ):
#        f=os.popen("rostopic list")
#        out = f.readlines()
#        list_of_topics = []
#        for item in out:
#            list_of_topics.append( item.rstrip('\n') )
#        dlg = wx.SingleChoiceDialog(self, 
#                    "List of topics",
#                    "Rostopic", list_of_topics)
#        string = ""
#        if(dlg.ShowModal() == wx.ID_OK):
#            selections = dlg.GetStringSelection()
#            string = selections
#        dlg.Destroy()
#        self.m_textCtrl3.SetValue(string)
#        event.Skip()
    def onRostopicList(self, event):
        f=os.popen("rostopic list")
        out = f.readlines()
        self.list_of_topics=[]
        for item in out:
            self.list_of_topics.append(item.rstrip('\n'))

#        print self.list_of_topics

        self.topicchecklist.Clear()
        for item in self.list_of_topics:
            index = self.topicchecklist.Append(item)

        if len(self.list_of_topics) > 0:
            self.topicchecklist.Select(0)

        f=os.popen("echo $ROS_MASTER_URI")
        txt = f.readline()
        self.SetStatusText("\nCurrent ROS_MASTER_URI: "+txt)
        event.Skip()

    
    def onRostopicEcho( self, event ):
        topicname=self.topicchecklist.GetStringSelection().encode('ascii', 'ignore')
        cmd = "rostopic echo %s"%topicname
        if self.topics_echo.GetValue():
            args = shlex.split(cmd)
            self.pid_topicecho= subprocess.Popen(args) #can also .check_output
        else:
            print "To be killed PID is", self.pid_topicecho.pid
            self.pid_topicecho.kill()
            self.pid_topicecho.wait()
            print "Topic echo Terminated."
        event.Skip()
    
    def onRostopicHz( self, event ):
        topicname=self.topicchecklist.GetStringSelection().encode('ascii', 'ignore')
        cmd = "rostopic hz %s"%topicname
        if self.topics_hz.GetValue():
            args = shlex.split(cmd)
            self.pid_topichz= subprocess.Popen(args) 
        else:
            self.pid_topichz.kill()
            self.pid_topichz.wait()
            print "Topic hz Terminated."
        event.Skip()
    
    def onRostopicInfo( self, event ):
        topicname=self.topicchecklist.GetStringSelection()
        os.system("rostopic info %s"%topicname)
        self.onRosnodeList(event)
        self.onRostopicList(event)
        event.Skip()
    
    def onRosnodeList( self, event ):
        self.list_of_nodes = rosnode.get_node_names()
        nodemachine_list = []
        master=scriptutil.get_master()
        print "\n\nClean up nodes..."
        self.rosnode_cleanup()
        for item in self.list_of_nodes:
            nodemachine_list.append(rosnode.get_api_uri(master, item))
            
        self.nodechecklist.DeleteAllItems()
        for i,item in enumerate(self.list_of_nodes):
            index = self.nodechecklist.InsertStringItem(sys.maxint, item)
            self.nodechecklist.SetStringItem(index, 1, nodemachine_list[i])
        if len(self.list_of_nodes) > 0:
            self.nodechecklist.Select(0)

        f=os.popen("echo $ROS_MASTER_URI")
        txt = f.readline()
        self.SetStatusText("\nCurrent ROS_MASTER_URI: "+txt)
#        dlg = wx.SingleChoiceDialog(self, 
#                    "List of nodes",
#                    "Rosnode", self.list_of_nodes)
#        string = ""
#        if(dlg.ShowModal() == wx.ID_OK):
#            selections = dlg.GetStringSelection()
#            string = selections
#        dlg.Destroy()
#        self.m_textCtrl4.SetValue(string)
        event.Skip()
  
    def get_selected_checked_nodes(self):
        num = self.nodechecklist.GetItemCount()
        selectlist = []
        checklist = []
        for i in range(num):
            if self.nodechecklist.IsSelected(i):
                selectlist.append(i)
            if self.nodechecklist.IsChecked(i):
                checklist.append(i)
        return selectlist, checklist

    def onTfMonitor(self, event):
        if self.m_button_tf_monitor.GetValue():
            cmd = "rosrun tf tf_monitor"
            args = shlex.split(cmd)
            self.pid_tfmonitor = subprocess.Popen(args)
        else:
            self.pid_tfmonitor.terminate()
            self.pid_tfmonitor.wait()
            print "Tf monitor Terminated."
        event.Skip()

    def onRosnodePing( self, event ):
        if self.nodes_ping.GetValue():
            self.selected_nodes, self.checked_nodes = self.get_selected_checked_nodes() 
            if self.selected_nodes is not [] or self.checked_nodes is not []:
                if len(self.selected_nodes) > 1 or len(self.checked_nodes) >1:
                    print "ATTENTION: Only the first selected or ticked node will be ping-ed!"
                nodename = ""
                if self.selected_nodes is not []:
                    nodename=self.nodechecklist.GetItemText(self.selected_nodes[0]).encode('ascii', 'ignore');
                else:
                    nodename=self.nodechecklist.GetItemText(self.checked_nodes[0]).encode('ascii', 'ignore');
                cmd = "rosnode ping %s"%nodename
                args = shlex.split(cmd)
                self.pid_nodeping = subprocess.Popen(args)
            else:
                wx.MessageBox('Please select a node', 'Info')
        else:
    #       os.kill(self.pid_nodeping.pid, signal.SIGKILL)
            #self.pid_nodeping.kill()
            self.pid_nodeping.terminate()
            self.pid_nodeping.wait()
            print "Node ping Terminated."
        event.Skip()
    
    def onRosnodeInfo( self, event ):
        self.selected_nodes, self.checked_nodes = self.get_selected_checked_nodes()
        if self.selected_nodes is not []: 
            if len(self.selected_nodes) > 1: 
                print "ATTENTION: Only the first selected node will be shown!"
            nodename=self.nodechecklist.GetItemText(self.selected_nodes[0]).encode('ascii', 'ignore');
            cmd = "rosnode info %s"%nodename
            os.system(cmd)
        else:
            wx.MessageBox('Please select a node', 'Info')
        self.onRostopicList(event)
        event.Skip()

    def onRosnodeKill( self, event ):
        self.selected_nodes, self.checked_nodes = self.get_selected_checked_nodes()
        if self.checked_nodes is not []: 
            for item in self.checked_nodes:
                nodename=self.nodechecklist.GetItemText(item).encode('ascii', 'ignore');
                cmd = "rosnode kill %s"%nodename
                os.system(cmd)
        else:
            wx.MessageBox('Please tick node(s)', 'Info')

        self.onRosnodeList(event)
        self.onRostopicList(event)
        event.Skip()

    def onRosnodeKillAll( self, event ):
        dial = wx.MessageDialog(None, 'Are you sure to Kill all the nodes?', 'Question', 
            wx.YES_NO | wx.NO_DEFAULT | wx.ICON_QUESTION)
        if (dial.ShowModal() == wx.ID_YES):
            print "Kill all nodes..."
            #dial.Destroy()
            rosnode.kill_nodes(self.list_of_nodes)
            self.rosnode_cleanup()
            self.list_of_nodes = rosnode.get_node_names()
        else:
            pass
        self.onRosnodeList(event)
        self.onRostopicList(event)
        event.Skip()

    def onDragInit(self, event):
        text = self.topicchecklist.GetStringSelection()
        self.m_textCtrl5.SetValue(text)
        event.Skip()
    
    def onImageView( self, event ):
        if self.m_textCtrl6.GetValue()=="":
            os.system("rosrun image_view image_view image:=%s &"%( self.m_textCtrl5.GetValue() ) )
        else:
            os.system("rosrun image_view image_view image:=%s _image_transport:=%s &"%(self.m_textCtrl5.GetValue(), self.m_textCtrl6.GetValue()))
        event.Skip()
   
    def onTfEcho(self, event):
        baseframe = self.m_tf1.GetValue()
        targetframe = self.m_tf2.GetValue()
        cmd = ("rosrun tf tf_echo %s %s"%(baseframe, targetframe)).encode('ascii', 'ignore')
        args = shlex.split(cmd)
        status = self.m_button_tfecho.GetValue()
        if event.GetEventType() == wx.EVT_TEXT_ENTER.evtType[0]:
            print "Enter Key detected."
            status = not status
        if status:
            if baseframe == '' or targetframe == '':
                wx.MessageBox('Please fill in both frame_id.', 'Error')
                self.m_button_tfecho.SetValue(0)
            else:
                self.pid_tfecho = subprocess.Popen(args)
        else:
            self.pid_tfecho.terminate()
            self.pid_tfecho.wait()
            print "Tf echo Terminated."
        event.Skip();
    
    def onRxgraph( self, event ):
        os.system("rxgraph &")
        event.Skip()
    
    def onRxconsole( self, event ):
        os.system("rxconsole &")
        event.Skip()
    def onMonitor( self, event ):
        os.system("rosrun robot_monitor robot_monitor &")
        event.Skip()

    def onRoswtf( self, event ):
        os.system("roswtf")
        event.Skip()
    
    def onRunRviz( self, event ):
        #os.system("rosrun rviz rviz &")
        os.system("roslaunch nifti_dev_gui rvizMapNav.launch &")
        event.Skip()
    
    def onNodesView(self, event):
        if self.m_button_nodes.GetValue():
            print "Show nodes view"
            #self.gSizer1.Show(self.Nodes, True)
            self.gSizer1.Add(self.Nodes, 1, wx.EXPAND, 5) #not successful
            self.gSizer1.Layout()
            
            self.Layout()
        else:
            size=self.Nodes.GetSize()
            gsize=self.gSizer1.GetSize()
            print "Hide nodes view"
            #self.gSizer1.Hide(self.Nodes)
            self.gSizer1.Remove(self.Nodes)
            self.Layout()
            #self.gSizer1.SetDimension(-1, -1, gsize.width - size.width, gsize.height)
        event.Skip()

    def onSize(self, event):
        size = event.GetSize()
        print ("%s, %s" % (size.width, size.height))
        print ("Workspace %s, %s" % (self.Workspace.GetSize().width, self.Workspace.GetSize().height))

        # tell the event system to continue looking for an event handler,
        # so the default handler will get called.
        event.Skip()

    # This method is called by the System when the window is moved,
    # because of the association above.
    def onMove(self, event):
        pos = event.GetPosition()
        print("%s, %s" % (pos.x, pos.y))
        event.Skip()

    def onKeys(self, event):
        keycode = event.GetKeyCode()
        if keycode == wx.WXK_ESCAPE:
            print "Quit."
            self.onQuit(event)
        event.Skip()

    def onShutoffRobot(self, event):
        shutdowndlg = ShutdownPanel(self, -1 )
        res = shutdowndlg.ShowModal()
        if res == wx.ID_YES:
            print "Shutdown the robot now. ",shutdowndlg.cmd
            shutoff_robot()
            self.SetStatusText("\nRobot is shuting down...")
            
        elif res == wx.ID_CANCEL:
            print "Cancel shutdown. ",shutdowndlg.cmd
            self.SetStatusText("\nRobot will not shut down.")
        shutdowndlg.Destroy()


    def update_launch_status(self):
        #disble all the components:
        for i, item in enumerate(self.list_launcher_check):
            item.Disable()
            self.list_file_view[i].Disable()
            self.list_choice[i].Disable()
            self.list_launch_button[i].Disable()
#            self.list_kill_button[i].Disable()
            self.list_kill_button[i].Enable()

        self.valid_launcher = []
        for i, item in enumerate(self.list_file_button):
            if self.list_launchfile[i][0] is not "" and self.list_launchfile[i][1] is not "":
                item.SetLabel(self.list_launchfile[i][1].split('.')[0])
                self.list_packs[i].SetLabel(self.list_launchfile[i][0])
                self.list_launcher_check[i].Enable()
                self.list_file_view[i].Enable()
                self.list_choice[i].Enable()
                self.list_launch_button[i].Enable()
                self.valid_launcher.append(i)
                
    def indent(self, elem, level=0):
        i = "\n" + level*"  "
        if len(elem):
            if not elem.text or not elem.text.strip():
                elem.text = i + "  "
            if not elem.tail or not elem.tail.strip():
                elem.tail = i
            for elem in elem:
                self.indent(elem, level+1)
            if not elem.tail or not elem.tail.strip():
                elem.tail = i
        else:
            if level and (not elem.tail or not elem.tail.strip()):
                elem.tail = i

    def savestates(self):
        root = ET.Element("dev_gui_status")
        for i, item in enumerate(self.list_launchfile):
            child = ET.Element("launch")
            child.set("pkg", item[0])
            child.set("file", item[1])
            child.set("where", str(self.list_choice[i].GetSelection()))
            root.append(child)

        child = ET.Element("robot")
        child.set("robotname", self.robotname.GetValue() )
        child.set("username", self.username.GetValue() )
        child.set("password", self.password.GetValue() )
        root.append(child)

        child = ET.Element("remote_ros_setup")
        child.set("ros_root", self.remote_ros_root )
        child.set("ros_pkg_path", self.remote_package_path )
        root.append(child)

        #for better looking
        self.indent(root)

        tree = ET.ElementTree(root)
        tree.write(logfile)
#        f = open(logfile, 'w')
#        f.write(ET.tostring(root))
#        f.close()


    def loadstates(self):
        global robotname
        global username
        global passw
        tree = ET.parse(logfile)
        root = tree.getroot()
        launcherlist = []
        for i,item in enumerate(root):
            #each sub-element
            if 'file' in item.keys():
                launcherlist.append( (item.attrib['pkg'], item.attrib['file']) )
                self.list_choice[i].SetSelection(int(item.attrib['where']))
            elif 'password' in item.keys():
                self.robotname.SetValue(item.attrib['robotname'])
                self.username.SetValue(item.attrib['username'])
                self.password.SetValue(item.attrib['password'])
                robotname = self.robotname.GetValue()
                username = self.username.GetValue()
                passw = self.password.GetValue()
            elif 'ros_root' in item.keys():
                self.remote_ros_root = item.attrib['ros_root'];
                self.remote_package_path = item.attrib['ros_pkg_path']
            else:
                print "\033[93m WARNING: XML file may be not valid. \033[0m"
                pass
        self.list_launchfile = launcherlist
        print "Launch files: ", self.list_launchfile
        self.update_launch_status()



    def rosnode_cleanup(self):
        self.list_of_nodes_raw = rosnode.get_node_names()
        self.list_of_nodes = []
        for n in self.list_of_nodes_raw:
            if n.startswith('rostopic_') or n.startswith('rviz_'):
                continue
            else:
                self.list_of_nodes.append(n)
        print "Start purging at background..."
        threading.Thread(target=self.purge_nodes).start()
        print "Started."


    def purge_nodes(self):
        master = scriptutil.get_master()
        pubs, subs, srvs = master.getSystemState('/')

#        pinged, unpinged = rosnode.rosnode_ping_all()
#        print pinged
#        print unpinged
        for n in self.list_of_nodes_raw:
            node_api = rosnode.get_api_uri(master,n)
            active_responce=True
            if rosnode.rosnode_ping(n, 1, False):
                active_responce=False
            if not active_responce:
                if n.startswith('rostopic_') or n.startswith('rviz_'):
                    print "Unregistering", n
                    for t, l in pubs:
                        if n in l:
                            master.unregisterPublisher(n, t, node_api)
                    for t, l in subs:
                        if n in l:
                            master.unregisterSubscriber(n, t, node_api)
                    for s, l in srvs:
                        if n in l:
                            service_api = master.lookupService('/', s)
                            master.unregisterService(n, s, service_api)
                rospy.logwarn("%s ping value is high (slow)."%n)
        print "INFO: Dummy nodes are purged!"


    def onQuit( self, event ):
        global launch_remote_core_pid
        self.savestates()
        if launch_remote_core:
            dial = wx.MessageDialog(None, 'Do you want to kill the remote ROSCORE that was started from this GUI?', 'Question', 
            wx.YES_NO | wx.NO_DEFAULT | wx.ICON_QUESTION)
            if (dial.ShowModal() == wx.ID_YES):
                print "Kill the remote deamon which started ROSCORE..."
                launch_remote_core_pid.kill()
                launch_remote_core_pid.wait()
                print "Remote core Terminated."
            dial.Destroy()
        self.flag_exit = True
        time.sleep(0.1)
        import sys
        sys.exit(0)

    def onCloseWindow(self, evt):
        self.onQuit(evt)



